/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.egreso;

import danielcortes.xyz.data.ConnectionHolder;
import danielcortes.xyz.data.DAOManager;
import danielcortes.xyz.data.SQLiteConnectionHolder;
import danielcortes.xyz.models.caja.Caja;
import danielcortes.xyz.models.caja.CajaDAO;
import danielcortes.xyz.models.tipo_egreso.TipoEgreso;
import danielcortes.xyz.models.tipo_egreso.TipoEgresoDAO;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.time.LocalDate;
import java.time.YearMonth;
import java.util.ArrayList;
import java.util.List;
import java.util.Optional;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

public class SQLiteEgresoDAO implements EgresoDAO {

  private static final Logger log = LogManager.getLogger(SQLiteEgresoDAO.class);
  private ConnectionHolder connectionHolder;

  public SQLiteEgresoDAO() {
    this.connectionHolder = new SQLiteConnectionHolder();
  }

  public SQLiteEgresoDAO(ConnectionHolder connectionHolder) {
    this.connectionHolder = connectionHolder;
  }

  @Override
  public List<Egreso> getAll() {
    log.debug("Se intentara conseguir todos los Egreso");
    List<Egreso> egresoList = new ArrayList<>();
    String query = "select * from egresos";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        try (ResultSet rs = ps.executeQuery()) {
          TipoEgresoDAO tipoEgresoDAO = DAOManager.getTipoEgresoDAO();
          CajaDAO cajaDAO = DAOManager.getCajaDAO();

          while (rs.next()) {
            //Confio en que la base de datos me dara un id existente
            @SuppressWarnings("OptionalGetWithoutIsPresent")
            TipoEgreso tipoEgreso = tipoEgresoDAO.getById(rs.getInt("tipo_egreso_id")).get();

            //Confio en que la base de datos me dara un id existente
            @SuppressWarnings("OptionalGetWithoutIsPresent")
            Caja caja = cajaDAO.getById(rs.getInt("caja_id")).get();

            Egreso egreso = new Egreso();
            egreso.setId(rs.getInt("id"));
            egreso.setNro(rs.getString("nro"));
            egreso.setDescripcion(rs.getString("descripcion"));
            egreso.setValor(rs.getInt("valor"));
            egreso.setTipoEgreso(tipoEgreso);
            egreso.setCaja(caja);

            egresoList.add(egreso);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir todos los Egreso");
    }
    log.debug("Se consiguieron " + egresoList.size() + " Egreso");
    return egresoList;
  }

  @Override
  public Optional<Egreso> getById(int id) {
    log.debug("Se intentara conseguir un Egreso con el id " + id);
    Egreso egreso = null;
    String query = "select * from egresos where id = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, id);
        try (ResultSet rs = ps.executeQuery()) {
          if (rs.next()) {
            TipoEgresoDAO tipoEgresoDAO = DAOManager.getTipoEgresoDAO();
            //Confio en que la base de datos me dara un id existente
            @SuppressWarnings("OptionalGetWithoutIsPresent")
            TipoEgreso tipoEgreso = tipoEgresoDAO.getById(rs.getInt("tipo_egreso_id")).get();

            CajaDAO cajaDAO = DAOManager.getCajaDAO();
            //Confio en que la base de datos me dara un id existente
            @SuppressWarnings("OptionalGetWithoutIsPresent")
            Caja caja = cajaDAO.getById(rs.getInt("caja_id")).get();

            egreso = new Egreso();
            egreso.setId(rs.getInt("id"));
            egreso.setNro(rs.getString("nro"));
            egreso.setDescripcion(rs.getString("descripcion"));
            egreso.setValor(rs.getInt("valor"));
            egreso.setTipoEgreso(tipoEgreso);
            egreso.setCaja(caja);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir el Egreso con id " + id, e);
    }
    log.debug("Se consiguio el egreso " + egreso);
    return Optional.ofNullable(egreso);
  }

  @Override
  public List<Egreso> getByCaja(Caja caja) {
    log.debug("Se intentara conseguir los egresos de la caja " + caja);
    List<Egreso> egresoList = new ArrayList<>();

    if (Caja.EMPTY == caja) {
      log.debug("La caja entregada es Caja.EMPY");
      return egresoList;
    }

    String query = "select * from egresos where caja_id = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, caja.getId());
        try (ResultSet rs = ps.executeQuery()) {
          while (rs.next()) {
            TipoEgresoDAO tipoEgresoDAO = DAOManager.getTipoEgresoDAO();
            //Confio en que la base de datos me dara un id existente
            @SuppressWarnings("OptionalGetWithoutIsPresent")
            TipoEgreso tipoEgreso = tipoEgresoDAO.getById(rs.getInt("tipo_egreso_id")).get();

            Egreso egreso = new Egreso();
            egreso.setId(rs.getInt("id"));
            egreso.setNro(rs.getString("nro"));
            egreso.setDescripcion(rs.getString("descripcion"));
            egreso.setValor(rs.getInt("valor"));
            egreso.setTipoEgreso(tipoEgreso);
            egreso.setCaja(caja);

            egresoList.add(egreso);
          }
        }
      }

    } catch (SQLException e) {
      log.error("Error al intentar conseguir los egreso de la caja " + caja, e);
    }
    log.debug("Se consieron " + egresoList.size() + " Egreso");
    return egresoList;
  }

  @Override
  public List<Egreso> getByNro(String nro) {
    log.debug("Se intentara conseguir los Egreso con nro " + nro);
    List<Egreso> egresoList = new ArrayList<>();
    String query = "select * from egresos where nro = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setString(1, nro);
        try (ResultSet rs = ps.executeQuery()) {
          TipoEgresoDAO tipoEgresoDAO = DAOManager.getTipoEgresoDAO();
          CajaDAO cajaDAO = DAOManager.getCajaDAO();

          while (rs.next()) {
            //Confio en que la base de datos me dara un id existente
            @SuppressWarnings("OptionalGetWithoutIsPresent")
            TipoEgreso tipoEgreso = tipoEgresoDAO.getById(rs.getInt("tipo_egreso_id")).get();
            //Confio en que la base de datos me dara un id existente
            @SuppressWarnings("OptionalGetWithoutIsPresent")
            Caja caja = cajaDAO.getById(rs.getInt("caja_id")).get();

            Egreso egreso = new Egreso();
            egreso.setId(rs.getInt("id"));
            egreso.setNro(rs.getString("nro"));
            egreso.setDescripcion(rs.getString("descripcion"));
            egreso.setValor(rs.getInt("valor"));
            egreso.setTipoEgreso(tipoEgreso);
            egreso.setCaja(caja);

            egresoList.add(egreso);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir los Egreso con nro " + nro, e);
    }
    log.debug("Se consiguieron " + egresoList.size() + " Egreso");
    return egresoList;
  }

  @Override
  public List<Egreso> getByTipoEgreso(TipoEgreso tipoEgreso) {
    log.debug("Se intentara conseguir los Egreso con TipoEgreso " + tipoEgreso);
    List<Egreso> egresoList = new ArrayList<>();

    if (TipoEgreso.EMPTY == tipoEgreso) {
      log.debug("El tipo egreso era TipoEgreso.EMPY");
      return egresoList;
    }

    String query = "select * from egresos where tipo_egreso_id = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, tipoEgreso.getId());
        try (ResultSet rs = ps.executeQuery()) {
          CajaDAO cajaDAO = DAOManager.getCajaDAO();
          while (rs.next()) {
            //Confio en que la base de datos me dara un id existente
            @SuppressWarnings("OptionalGetWithoutIsPresent")
            Caja caja = cajaDAO.getById(rs.getInt("caja_id")).get();

            Egreso egreso = new Egreso();
            egreso.setId(rs.getInt("id"));
            egreso.setNro(rs.getString("nro"));
            egreso.setDescripcion(rs.getString("descripcion"));
            egreso.setValor(rs.getInt("valor"));
            egreso.setTipoEgreso(tipoEgreso);
            egreso.setCaja(caja);

            egresoList.add(egreso);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir los Egreso para el TipoEgreso " + tipoEgreso, e);
    }
    log.debug("Se consiguieron " + egresoList.size() + " Egresos");
    return egresoList;
  }

  @Override
  public List<Egreso> getByTipoEgresoEnCaja(TipoEgreso tipoEgreso, Caja caja) {
    log.debug("Se intentara conseguir los Egresos pertencienes al tipoEgreso " + tipoEgreso
        + " y a la caja " + caja);
    List<Egreso> egresoList = new ArrayList<>();

    if (caja == Caja.EMPTY || tipoEgreso == TipoEgreso.EMPTY) {
      log.debug("La caja o el tipoEgreso eran EMPTY");
      return egresoList;
    }

    String query = "select * from egresos where tipo_egreso_id = ? and caja_id = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, tipoEgreso.getId());
        ps.setInt(2, caja.getId());
        try (ResultSet rs = ps.executeQuery()) {
          while (rs.next()) {
            Egreso egreso = new Egreso();
            egreso.setId(rs.getInt("id"));
            egreso.setNro(rs.getString("nro"));
            egreso.setDescripcion(rs.getString("descripcion"));
            egreso.setValor(rs.getInt("valor"));
            egreso.setTipoEgreso(tipoEgreso);
            egreso.setCaja(caja);

            egresoList.add(egreso);
          }
        }
      }
    } catch (SQLException e) {
      log.error(
          "Error al intentar conseguir los egresos pertenecientes al tipoEgreso " + tipoEgreso
              + " y a la caja " + caja, e);
    }
    return egresoList;
  }

  @Override
  public int getTotalEgreso(Caja caja) {
    log.debug("Se intentara conseguir la suma de egreso de la caja " + caja);
    int total = 0;

    if (Caja.EMPTY == caja) {
      log.debug("La caja era Caja.EMPTY");
      return total;
    }

    String query = "select sum(valor) from egresos where caja_id = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, caja.getId());
        try (ResultSet rs = ps.executeQuery()) {
          if (rs.next()) {
            total = rs.getInt(1);
          }
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar conseguir la suma de egresos de la caja " + caja, e);

    }
    log.debug("El total obtenido es " + total);
    return total;
  }

  @Override
  public int getTotalEgresoMesPorTipo(YearMonth mes, TipoEgreso tipo) {
    log.debug(
        "Se intentara conseguir el total de egresos en el mes " + mes + " y del tipo " + tipo);
    int total = 0;

    if (TipoEgreso.EMPTY == tipo) {
      log.debug("El TipoEgreso era TipoEgreso.EMPTY");
      return total;
    }

    LocalDate start = mes.atDay(1);
    LocalDate end = mes.atEndOfMonth();
    String query = "select sum(valor) from egresos inner join caja on (egresos.caja_id = caja.id) where fecha between ? and ? and tipo_egreso_id = ?";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setString(1, start.toString());
        ps.setString(2, end.toString());
        ps.setInt(3, tipo.getId());
        try (ResultSet rs = ps.executeQuery()) {
          if (rs.next()) {
            total = rs.getInt(1);
          }
        }
      }
    } catch (SQLException e) {
      log.error(
          "Error al intentar conseguir la suma de egresos en el mes " + mes + " y del tipo egreso "
              + tipo, e);
    }
    log.debug("El total obtenido es " + total);
    return total;
  }

  @Override
  public void insert(Egreso egreso) {
    log.debug("Se intentara insertar el egreso " + egreso);
    String query = "insert into egresos (nro, descripcion, valor, tipo_egreso_id, caja_id) values (?,?,?,?,?)";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setString(1, egreso.getNro());
        ps.setString(2, egreso.getDescripcion());
        ps.setInt(3, egreso.getValor());
        ps.setInt(4, egreso.getTipoEgreso().getId());
        ps.setInt(5, egreso.getCaja().getId());
        ps.executeUpdate();
      }
      try (PreparedStatement ps = conn.prepareStatement("select last_insert_rowid()")) {
        try (ResultSet rs = ps.executeQuery()) {
          rs.next();
          egreso.setId(rs.getInt(1));
        }
      }
    } catch (SQLException e) {
      log.error("Error al intentar insertar el egreso " + egreso, e);
    }
    log.debug("Se inserto el egreso " + egreso);
  }

  @Override
  public void update(Egreso egreso) {
    log.debug("Se intentara actualizar el egreso " + egreso);
    String query = "update egresos set nro = ?, descripcion = ?, valor = ?, tipo_egreso_id = ?, caja_id = ? where id = ? ";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setString(1, egreso.getNro());
        ps.setString(2, egreso.getDescripcion());
        ps.setInt(3, egreso.getValor());
        ps.setInt(4, egreso.getTipoEgreso().getId());
        ps.setInt(5, egreso.getCaja().getId());
        ps.setInt(6, egreso.getId());
        ps.executeUpdate();
      }
    } catch (SQLException e) {
      log.error("Error al intentar actualizar el egreso " + egreso, e);
    }
    log.debug("Se actualizo el egreso " + egreso);
  }

  @Override
  public void delete(Egreso egreso) {
    log.debug("Se intentara eliminar el egreso " + egreso);
    String query = "delete from egresos where id = ? ";
    try (Connection conn = connectionHolder.getConnection()) {
      try (PreparedStatement ps = conn.prepareStatement(query)) {
        ps.setInt(1, egreso.getId());
        ps.executeUpdate();
      }
    } catch (SQLException e) {
      log.error("Error al intentar actualizar el egreso " + egreso);
    }
    log.debug("Se elimino el egreso " + egreso);
  }
}
